#!/bin/bash
# common.sh - common functions for OPS app

# get_auth_string()
function get_auth_string() {
	if ! session_verify "${cookies[sh_session]}"; then
		exit 0
	fi

	user="$(session_get_username ${cookies[sh_session]})"

	echo "Authorization: Bearer $(cat secret/authTokens.dat | grep -P "^$user:" | sed -s "s/$user://")"
}

function get_refresh_token() {
	if ! session_verify "${cookies[sh_session]}"; then
		exit 0
	fi

	user="$(session_get_username ${cookies[sh_session]})"

	echo "$(cat secret/refreshTokens.dat | grep -P "^$user:" | sed -s "s/$user://")"
}

# check_if_user_exists(file)
function check_if_user_exists() {
	if ! session_verify "${cookies[sh_session]}"; then
			exit 0
	fi

	user=$(session_get_username ${cookies[sh_session]})

	[[ $1 == "refreshToken" ]] && [[ $(cat secret/refreshTokens.dat | grep -P "^$user:") != "" ]] && return 1
	[[ $1 == "authToken" ]] && [[ $(cat secret/authTokens.dat | grep -P "^$user:") != "" ]] && return 1
	return 0
}

# add_account_refreshtoken(refreshtoken)
function add_account_refreshtoken() {
	if ! session_verify "${cookies[sh_session]}"; then
		exit 0
	fi
	
	if check_if_user_exists refreshToken; then
		echo "$(session_get_username ${cookies[sh_session]}):$1" >> secret/refreshTokens.dat
	fi
}


# add_account_authtoken(authtoken)
function add_account_authtoken() {
	if ! session_verify "${cookies[sh_session]}"; then
		exit 0
	fi

	if check_if_user_exists authToken; then
		echo "$(session_get_username ${cookies[sh_session]}):$1" >> secret/authTokens.dat
	fi
}

# update_account_authtoken(username)
function update_account_authtoken() {
	a=$(cat secret/refreshTokens.dat | grep -P "^$1\:")
	token=$(awk -F: '{print $2}' <<< $a);
	auth=$(curl -s -X POST -H "Content-type: application/json" --data '{"phoneOS": "Android", "refreshToken": "'"$token"'"}' https://api-inmobile-pl.easypack24.net/v1/authenticate | jq -r .authToken | sed -s 's/Bearer //g')
	sed -E -i 's/^'"$1"':.*/'"$1:$auth"'/g' secret/authTokens.dat
}
