const gulp = require("gulp");
const ts = require("gulp-typescript");
const sourceMaps = require("gulp-sourcemaps");
const babel = require("gulp-babel");
const sass = require("gulp-sass");

const tsProject = ts.createProject("tsconfig.json");
const buildTs = () =>
  tsProject
    .src()
    .pipe(sourceMaps.init())
    .pipe(ts({}))
    .pipe(
      babel({
        presets: ["@babel/env", "minify"],
        comments: false,
      }),
    )
    .pipe(sourceMaps.write("."))
    .pipe(gulp.dest("build"));

const buildSass = () =>
  gulp
    .src("src/*.scss")
    .pipe(sourceMaps.init())
    .pipe(
      sass({
        outputStyle: "compressed",
      }),
    )
    .pipe(sourceMaps.write("."))
    .pipe(gulp.dest("build"));

gulp.task("build:ts", buildTs);
gulp.task("build:sass", buildSass);

gulp.task("build", gulp.parallel(buildTs, buildSass));
